package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityPatternStorage;
import ru.dbotthepony.mc.otm.menu.slot.PatternSlot;

public class PatternStorageMenu extends MatteryMenu {
	public PatternStorageMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public PatternStorageMenu(int p_38852_, Inventory inventory, BlockEntityPatternStorage tile) {
		super(Registry.Menus.PATTERN_STORAGE, p_38852_, inventory, tile);

		Container patterns = tile != null ? tile.patterns : new SimpleContainer(3 * 3);

		for (int row = 0; row < 3; row++)
			for (int column = 0; column < 3; column++)
				addSlot(new PatternSlot(patterns, row * 3 + column, 64 + column * 18, 20 + row * 18));

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 3 * 3;
	}
}
